LeetCode-73. 矩阵置零【数组 哈希表 矩阵】

LeetCode-73. 矩阵置零【数组 哈希表 矩阵】

  • 题目描述:
  • [解题思路一:用 O(m+n)额外空间,两遍扫matrix,第一遍用集合记录哪些行,哪些列有0;第二遍置0](#解题思路一:用 O(m+n)额外空间,两遍扫matrix,第一遍用集合记录哪些行,哪些列有0;第二遍置0)
  • [解题思路二:用O(1)空间,关键思想: 用matrix第一行和第一列记录该行该列是否有0,作为标志位。【因为假如这一行或者列有0,那么第一行或第一列之后也必须置0。这其实和第一种思路差不多,只不过用matrix第一行和列将额外空间省去】](#解题思路二:用O(1)空间,关键思想: 用matrix第一行和第一列记录该行该列是否有0,作为标志位。【因为假如这一行或者列有0,那么第一行或第一列之后也必须置0。这其实和第一种思路差不多,只不过用matrix第一行和列将额外空间省去】)
  • 解题思路三:优化。使用一个标记变量

题目描述:

给定一个 m x n 的矩阵,如果一个元素为 0 ,则将其所在行和列的所有元素都设为 0 。请使用 原地 算法。

示例 1:

输入:matrix = \[1,1,1,1,0,1,1,1,1]

输出:\[1,0,1,0,0,0,1,0,1]

示例 2:

输入:matrix = \[0,1,2,0,3,4,5,2,1,3,1,5]

输出:\[0,0,0,0,0,4,5,0,0,3,1,0]

提示:

m == matrix.length

n == matrix0.length

1 <= m, n <= 200

-231 <= matrixij <= 231 - 1

解题思路一:用 O(m+n)额外空间,两遍扫matrix,第一遍用集合记录哪些行,哪些列有0;第二遍置0

python 复制代码
class Solution:
    def setZeroes(self, matrix: List[List[int]]) -> None:
        """
        Do not return anything, modify matrix in-place instead.
        """
        m, n = len(matrix), len(matrix[0])
        rows = [0] * m
        cols = [0] * n
        for i in range(m):
            for j in range(n):
                if matrix[i][j] == 0:
                    rows[i] = 1
                    cols[j] = 1
        for i, row in enumerate(rows):
            if row == 1:
                for j in range(n):
                    matrix[i][j] = 0
        for i, col in enumerate(cols):
            if col == 1:
                for j in range(m):
                    matrix[j][i] = 0
# 或用set()
class Solution:
    def setZeroes(self, matrix: List[List[int]]) -> None:
        """
        Do not return anything, modify matrix in-place instead.
        """
        row = len(matrix)
        col = len(matrix[0])
        row_zero = set()
        col_zero = set()
        for i in range(row):
            for j in range(col):
                if matrix[i][j] == 0:
                    row_zero.add(i)
                    col_zero.add(j)
        for i in range(row):
            for j in range(col):
                if i in row_zero or j in col_zero:
                    matrix[i][j] = 0

时间复杂度:O(nm)

空间复杂度:O(n+m)

解题思路二:用O(1)空间,关键思想: 用matrix第一行和第一列记录该行该列是否有0,作为标志位。【因为假如这一行或者列有0,那么第一行或第一列之后也必须置0。这其实和第一种思路差不多,只不过用matrix第一行和列将额外空间省去】

但是对于第一行,和第一列要设置一个标志位,为了防止自己这一行(一列)也有0的情况.注释写在代码里,直接看代码很好理解!

python 复制代码
class Solution:
    def setZeroes(self, matrix: List[List[int]]) -> None:
        """
        Do not return anything, modify matrix in-place instead.
        """
        row = len(matrix)
        col = len(matrix[0])
        row0_flag = False
        col0_flag = False
        # 找第一行是否有0
        for j in range(col):
            if matrix[0][j] == 0:
                row0_flag = True
                break
        # 第一列是否有0
        for i in range(row):
            if matrix[i][0] == 0:
                col0_flag = True
                break

        # 把第一行或者第一列作为 标志位
        for i in range(1, row):
            for j in range(1, col):
                if matrix[i][j] == 0:
                    matrix[i][0] = matrix[0][j] = 0
        #print(matrix)
        # 置0
        for i in range(1, row):
            for j in range(1, col):
                if matrix[i][0] == 0 or matrix[0][j] == 0:
                    matrix[i][j] = 0

        if row0_flag:
            for j in range(col):
                matrix[0][j] = 0
        if col0_flag:
            for i in range(row):
                matrix[i][0] = 0

时间复杂度:O(nm)

空间复杂度:O(1)

解题思路三:优化。使用一个标记变量

我们可以对方法二进一步优化,只使用一个标记变量记录第一列是否原本存在 000。这样,第一列的第一个元素即可以标记第一行是否出现 000。但为了防止每一列的第一个元素被提前更新,我们需要从最后一行开始,倒序地处理矩阵元素。

python 复制代码
class Solution:
    def setZeroes(self, matrix: List[List[int]]) -> None:
        m, n = len(matrix), len(matrix[0])
        flag_col0 = False
        
        for i in range(m):
            if matrix[i][0] == 0:
                flag_col0 = True
            for j in range(1, n):
                if matrix[i][j] == 0:
                    matrix[i][0] = matrix[0][j] = 0
        
        for i in range(m - 1, -1, -1):
            for j in range(1, n):
                if matrix[i][0] == 0 or matrix[0][j] == 0:
                    matrix[i][j] = 0
            if flag_col0:
                matrix[i][0] = 0

时间复杂度:O(nm)

空间复杂度:O(1)

相关推荐
苏打豆3 小时前
CRISP源码阅读——基于ROS2力矩反馈控制器与速度加速度零空间
c++·线性代数·算法·矩阵·机器人
蛋蛋的就会顺顺的3 小时前
hot100——矩阵
java·数据结构·算法·leetcode·力扣
老歌老听老掉牙3 小时前
麻花钻切屑形态演变的力学机制与临界条件分析
python·算法·钻头
zhangfeng11334 小时前
国产GPU/AI算力芯片现状(修订完整版 · 截至2026年9月
人工智能·算法·ai编程·npu
学代码的CJY4 小时前
从代码出发理解时间复杂度与空间复杂度
数据结构·算法
白帽攻防录5 小时前
SRC 挖洞:WSO2 JWT 算法混淆绕过深度复盘,CVE-2026-5430 不支持的算法怎么变成管理员
网络·算法·安全·网络安全·jwt
小O的算法实验室5 小时前
IEEE TEVC,基于精确与DQN群智能调度方法用于多目标异构USV
算法
字节跳动的猫6 小时前
LikeShop 积分体系全链路改造:获取规则、订单抵扣与积分商品兑换二开
运维·数据结构
可乐ea6 小时前
AI Agent 工具调用准确性评测:选择错误与参数错误分开测
大数据·人工智能·算法·大模型·工具调用·ai智能体·agent评测
上位机妹子6 小时前
C 语言 数组删除指定元素(快慢指针法)
c语言·数据结构·算法